! newmark.f90
subroutine newmark( m, k, c, dt, f, x0 , xp0, n, x, xp, xpp)
  Implicit none
  
  integer(kind=4) :: i, n
  real(kind=8) :: m, k, c
  real(kind=8) :: dt, x0, xp0
  real(kind=8) :: f(n)
  real(kind=8) :: x(n), xp(n), xpp(n), dxx(n)
  real(kind=8) :: gamma, beta, khat, a, b
  real(kind=8) :: df, dx, dxp, dxpp

!f2py intent(in) m, k, c
!f2py intent(in) dt, f, xo, xp0
!f2py intent(out) x, xp, xpp
  
  gamma = 1./2.
  beta = 1./4.
  
  x(1) = x0
  xp(1) = xp0
  xpp(1) = (f(1)-c*xp0-k*x0)/m
  
  khat = k + gamma/(beta*dt)*c + 1./(beta*dt**2)*m
  a = 1./(beta*dt)*m + gamma/beta*c
  b = 1./(2.*beta)*m + dt*(gamma/(2.*beta)-1.)*c
  
  do i=1,n-1
    df = (f(i+1)-f(i))+a*xp(i)+b*xpp(i)
    dx = df/khat
    dxp = gamma/(beta*dt)*dx - gamma/beta*xp(i) + dt*(1.-gamma/(2.*beta))*xpp(i)
    dxpp = 1./(beta*dt**2)*dx - 1./(beta*dt)*xp(i) - 1./(2.*beta)*xpp(i)
    x(i+1) = x(i)+dx
    xp(i+1) = xp(i)+dxp
    xpp(i+1) = xpp(i)+dxpp
  end do

end subroutine 

! python -m numpy.f2py --compiler=mingw32 --fcompiler=gfortran -c -m newmark newmark.f90

